<?php
/*
Plugin Name: Buffer Button
Plugin URI: http://blog.bufferapp.com/buffer-button
Description: Add the Buffer Button to your blog
Author: Buffer (Joel Gascoigne)
Version: 0.1
Author URI: http://bufferapp.com
License: GPL2
*/

class buffer_button {
	
	function get_options() {
		// retrieve saved parameters, and set defaults
		$buffer_button_count = get_option("buffer_button_count");
		if(empty($buffer_button_count)) $buffer_button_count = "horizontal";
		$buffer_button_via = get_option("buffer_button_via");
		if(empty($buffer_button_via)) $buffer_button_via = "bufferapp";
		$buffer_button_custom_css = get_option("buffer_button_custom_css");
		if(empty($buffer_button_custom_css)) $buffer_button_custom_css = "float: right; margin: 10px;";
		
		return 	array(
					'buffer_button_count' => $buffer_button_count,
					'buffer_button_via' => $buffer_button_via,
					'buffer_button_custom_css' => $buffer_button_custom_css
				);
	}
	
	function the_content($content) {
		
		// grab the options
		$options = call_user_func(array('buffer_button', 'get_options'));
		
		$content = '<div style="'.$options['buffer_button_custom_css'].'"><a href="http://bufferapp.com/add" class="buffer-add-button" data-text="'.the_title('','',false).'" data-url="'.get_permalink().'" data-via="'.$options['buffer_button_via'].'" data-count="'.$options['buffer_button_count'].'">Buffer</a><script type="text/javascript" src="http://static.bufferapp.com/js/button.js"></script></div>'.$content;
		return $content;
	}

	function admin_menu() {
		add_options_page('Buffer Button Options', 'Buffer Button', 'manage_options', 'buffer-button', array('buffer_button', 'options_page'));
	}

	function options_page() {
		if (isset($_POST['buffer_save'])) call_user_func(array('buffer_button', 'save_options'), $_POST);
		if (!current_user_can('manage_options'))  {
			wp_die( __('You do not have sufficient permissions to access this page.') );
		}
		
		// grab the options
		$options = call_user_func(array('buffer_button', 'get_options'));
		
		$html = '<div class="wrap">
			<div id="icon-options-general" class="icon32"><br></div>
		<h2>Buffer Button Settings</h2>

		<form name="buffer_button_form" method="post" action="/wp-admin/options-general.php?page=buffer-button">
		<table class="form-table">
			<tbody>
				<tr valign="top">
				<th scope="row"><label for="buffer_button_count">Buffer Button Style</label></th>
				<td>
					<select name="buffer_button_count" id="buffer_button_count">
						<option value="none"';
						if($options['buffer_button_count']=='none') $html .= ' selected="selected"';
						$html .= '>None</option>';
						$html .= '<option value="horizontal"';
						if($options['buffer_button_count']=='horizontal') $html .= ' selected="selected"';
						$html .= '>Horizontal (small)</option>';
						$html .= '<option value="vertical"';
						if($options['buffer_button_count']=='vertical') $html .= ' selected="selected"';
						$html .= '>Vertical (big)</option>
					</select>
				</td>
				</tr>
				<tr valign="top">
				<th scope="row"><label for="buffer_button_via">Mention this @username:</label></th>
				<td>
				@<input name="buffer_button_via" type="text" id="buffer_button_via" value="'.$options['buffer_button_via'].'" class="medium-text"></td>
				</tr>
			</tbody>
		</table>


		<p class="submit"><input type="submit" name="buffer_save" id="submit" class="button-primary" value="Save Changes"></p></form>
		</div>';
		echo $html;
	}
	
	function save_options($post) {
		update_option('buffer_button_count', $post['buffer_button_count']);
		update_option('buffer_button_via', $post['buffer_button_via']);
		echo '<div id="message" class="updated"><p>Buffer Button settings updated.</p></div>';
	}
}

add_action('the_content', array('buffer_button', 'the_content'));
add_action('admin_menu', array('buffer_button', 'admin_menu'));